diff --git a/Makefile.am b/Makefile.am
index 28036bf..31f991e 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -1,8 +1,10 @@
 SUBDIRS = \
-	camel mail \
-	addressbook calendar \
-	storage \
-	po docs
+	tools \
+	camel \
+	addressbook \
+	calendar \
+	po \
+	docs
 
 DISTCLEANFILES = \
 	intltool-extract \
diff --git a/camel/Makefile.am b/camel/Makefile.am
index 0195f84..a10e9cc 100644
--- a/camel/Makefile.am
+++ b/camel/Makefile.am
@@ -21,8 +21,8 @@ libcamelexchange_la_SOURCES =  \
 	camel-exchange-store.c \
 	camel-exchange-summary.c \
 	camel-exchange-transport.c \
-	camel-stub-marshal.c \
-	camel-stub.c
+	camel-exchange-utils.c \
+	mail-utils.c
 
 noinst_HEADERS = \
 	camel-exchange-folder.h \
@@ -31,17 +31,17 @@ noinst_HEADERS = \
 	camel-exchange-store.h \
 	camel-exchange-summary.h \
 	camel-exchange-transport.h \
-	camel-stub-constants.h \
-	camel-stub-marshal.h \
-	camel-stub.h
+	camel-exchange-utils.h \
+	mail-utils.h
 
 libcamelexchange_la_LDFLAGS = -avoid-version -module $(NO_UNDEFINED)
 
-libcamelexchange_la_LIBADD =  \
-	$(LDAP_LIBS) \
-	$(LIBEXCHANGE_LIBS) \
-	$(EXCHANGE_STORAGE_LIBS) \
-	$(SOCKET_LIBS) \
+libcamelexchange_la_LIBADD =		\
+	$(top_builddir)/tools/libevolution-exchange-shared.la \
+	$(LDAP_LIBS)			\
+	$(LIBEXCHANGE_LIBS)		\
+	$(EXCHANGE_STORAGE_LIBS)	\
+	$(SOCKET_LIBS)			\
 	$(PTHREAD_LIB)
 
 EXTRA_DIST = libcamelexchange.urls
diff --git a/camel/camel-exchange-folder.c b/camel/camel-exchange-folder.c
index 54b8c1c..74ea777 100644
--- a/camel/camel-exchange-folder.c
+++ b/camel/camel-exchange-folder.c
@@ -30,12 +30,6 @@
 #include <glib/gi18n-lib.h>
 #include <libedataserver/e-data-server-util.h>
 
-#include "camel-exchange-folder.h"
-#include "camel-exchange-search.h"
-#include "camel-exchange-store.h"
-#include "camel-exchange-summary.h"
-#include "camel-exchange-journal.h"
-
 #include <camel/camel-data-wrapper.h>
 #include <camel/camel-exception.h>
 #include <camel/camel-file-utils.h>
@@ -48,6 +42,13 @@
 #include <camel/camel-folder-summary.h>
 #include <camel/camel-string-utils.h>
 
+#include "camel-exchange-folder.h"
+#include "camel-exchange-search.h"
+#include "camel-exchange-store.h"
+#include "camel-exchange-summary.h"
+#include "camel-exchange-journal.h"
+#include "camel-exchange-utils.h"
+
 static CamelOfflineFolderClass *parent_class = NULL;
 
 /* Returns the class for a CamelFolder */
@@ -178,18 +179,11 @@ refresh_info (CamelFolder *folder, CamelException *ex)
 	if (camel_exchange_store_connected (store, ex)) {
 		camel_offline_journal_replay (exch->journal, NULL);
 
-		camel_stub_send (exch->stub, ex, CAMEL_STUB_CMD_REFRESH_FOLDER,
-				 CAMEL_STUB_ARG_FOLDER, folder->full_name,
-				 CAMEL_STUB_ARG_END);
+		camel_exchange_utils_refresh_folder (CAMEL_SERVICE (folder->parent_store), folder->full_name, ex);
 	}
 
 	/* sync up the counts now */
-	if (!camel_stub_send (exch->stub, ex, CAMEL_STUB_CMD_SYNC_COUNT,
-				 CAMEL_STUB_ARG_FOLDER, folder->full_name,
-				 CAMEL_STUB_ARG_RETURN,
-				 CAMEL_STUB_ARG_UINT32, &unread_count,
-				 CAMEL_STUB_ARG_UINT32, &visible_count,
-				 CAMEL_STUB_ARG_END)) {
+	if (!camel_exchange_utils_sync_count (CAMEL_SERVICE (folder->parent_store), folder->full_name, &unread_count, &visible_count, ex)) {
 		g_print("\n Error syncing up the counts");
 	}
 
@@ -200,7 +194,6 @@ refresh_info (CamelFolder *folder, CamelException *ex)
 static void
 exchange_expunge (CamelFolder *folder, CamelException *ex)
 {
-	CamelExchangeFolder *exch = CAMEL_EXCHANGE_FOLDER (folder);
 	CamelFolder *trash;
 	GPtrArray *uids;
 	CamelExchangeStore *store = CAMEL_EXCHANGE_STORE (folder->parent_store);
@@ -218,10 +211,7 @@ exchange_expunge (CamelFolder *folder, CamelException *ex)
 	}
 
 	uids = camel_folder_get_uids (trash);
-	camel_stub_send (exch->stub, ex, CAMEL_STUB_CMD_EXPUNGE_UIDS,
-			 CAMEL_STUB_ARG_FOLDER, trash->full_name,
-			 CAMEL_STUB_ARG_STRINGARRAY, uids,
-			 CAMEL_STUB_ARG_END);
+	camel_exchange_utils_expunge_uids (CAMEL_SERVICE (trash->parent_store), trash->full_name, uids, ex);
 	camel_folder_free_uids (trash, uids);
 	camel_object_unref (CAMEL_OBJECT (trash));
 }
@@ -240,14 +230,13 @@ append_message_data (CamelFolder *folder, GByteArray *message,
 	if (!subject)
 		subject = _("No Subject");
 
-	if (camel_stub_send (exch->stub, ex, CAMEL_STUB_CMD_APPEND_MESSAGE,
-			     CAMEL_STUB_ARG_FOLDER, folder->full_name,
-			     CAMEL_STUB_ARG_UINT32, info? camel_message_info_flags(info): 0,
-			     CAMEL_STUB_ARG_STRING, subject,
-			     CAMEL_STUB_ARG_BYTEARRAY, message,
-			     CAMEL_STUB_ARG_RETURN,
-			     CAMEL_STUB_ARG_STRING, &new_uid,
-			     CAMEL_STUB_ARG_END)) {
+	if (camel_exchange_utils_append_message (CAMEL_SERVICE (folder->parent_store),
+				folder->full_name,
+				info ? camel_message_info_flags (info) : 0,
+				subject,
+				message,
+				&new_uid,
+				ex)) {
 		stream_cache = camel_data_cache_add (exch->cache,
 						     "cache", new_uid, NULL);
 		if (stream_cache) {
@@ -405,12 +394,7 @@ get_message_data (CamelFolder *folder, const gchar *uid, CamelException *ex)
 		return NULL;
 	}
 
-	if (!camel_stub_send (exch->stub, ex, CAMEL_STUB_CMD_GET_MESSAGE,
-			      CAMEL_STUB_ARG_FOLDER, folder->full_name,
-			      CAMEL_STUB_ARG_STRING, uid,
-			      CAMEL_STUB_ARG_RETURN,
-			      CAMEL_STUB_ARG_BYTEARRAY, &ba,
-			      CAMEL_STUB_ARG_END))
+	if (!camel_exchange_utils_get_message (CAMEL_SERVICE (folder->parent_store), folder->full_name, uid, &ba, ex))
 		return NULL;
 
 	stream = camel_data_cache_add (exch->cache, "cache", uid, ex);
@@ -544,7 +528,6 @@ transfer_messages_the_hard_way (CamelFolder *source, GPtrArray *uids,
 				GPtrArray **transferred_uids,
 				gboolean delete_originals, CamelException *ex)
 {
-	CamelExchangeFolder *exch_source = CAMEL_EXCHANGE_FOLDER (source);
 	CamelException local_ex;
 	CamelMessageInfo *info;
 	GByteArray *ba;
@@ -585,16 +568,12 @@ transfer_messages_the_hard_way (CamelFolder *source, GPtrArray *uids,
 	}
 
 	if (delete_originals) {
-		camel_stub_send (exch_source->stub, ex,
-				 CAMEL_STUB_CMD_EXPUNGE_UIDS,
-				 CAMEL_STUB_ARG_FOLDER, source->full_name,
-				 CAMEL_STUB_ARG_STRINGARRAY, uids,
-				 CAMEL_STUB_ARG_END);
+		camel_exchange_utils_expunge_uids (CAMEL_SERVICE (source->parent_store), source->full_name, uids, ex);
 	}
 }
 
 static void
-cache_xfer (CamelExchangeFolder *stub_source, CamelExchangeFolder *stub_dest,
+cache_xfer (CamelExchangeFolder *folder_source, CamelExchangeFolder *folder_dest,
 	    GPtrArray *src_uids, GPtrArray *dest_uids, gboolean delete)
 {
 	CamelStream *src, *dest;
@@ -604,12 +583,12 @@ cache_xfer (CamelExchangeFolder *stub_source, CamelExchangeFolder *stub_dest,
 		if (!*(gchar *)dest_uids->pdata[i])
 			continue;
 
-		src = camel_data_cache_get (stub_source->cache, "cache",
+		src = camel_data_cache_get (folder_source->cache, "cache",
 					    src_uids->pdata[i], NULL);
 		if (!src)
 			continue;
 
-		dest = camel_data_cache_add (stub_dest->cache, "cache",
+		dest = camel_data_cache_add (folder_dest->cache, "cache",
 					     dest_uids->pdata[i], NULL);
 		if (dest) {
 			camel_stream_write_to_stream (src, dest);
@@ -618,7 +597,7 @@ cache_xfer (CamelExchangeFolder *stub_source, CamelExchangeFolder *stub_dest,
 		camel_object_unref (CAMEL_OBJECT (src));
 
 		if (delete) {
-			camel_data_cache_remove (stub_source->cache, "cache",
+			camel_data_cache_remove (folder_source->cache, "cache",
 						 src_uids->pdata[i], NULL);
 		}
 	}
@@ -684,25 +663,20 @@ transfer_messages_to (CamelFolder *source, GPtrArray *uids,
 		return;
 	}
 
-	if (camel_stub_send (exch_source->stub, ex,
-			     CAMEL_STUB_CMD_TRANSFER_MESSAGES,
-			     CAMEL_STUB_ARG_FOLDER, source->full_name,
-			     CAMEL_STUB_ARG_FOLDER, dest->full_name,
-			     CAMEL_STUB_ARG_STRINGARRAY, uids,
-			     CAMEL_STUB_ARG_UINT32, (guint32)delete_originals,
-			     CAMEL_STUB_ARG_RETURN,
-			     CAMEL_STUB_ARG_STRINGARRAY, &ret_uids,
-			     CAMEL_STUB_ARG_END)) {
+	if (camel_exchange_utils_transfer_messages (CAMEL_SERVICE (store),
+				source->full_name,
+				dest->full_name,
+				uids,
+				delete_originals,
+				&ret_uids,
+				ex)) {
 		if (ret_uids->len != 0)
 			cache_xfer (exch_source, exch_dest, uids, ret_uids, FALSE);
 
 		if (transferred_uids)
 			*transferred_uids = ret_uids;
 		else {
-			gint i;
-
-			for (i = 0; i < ret_uids->len; i++)
-				g_free (ret_uids->pdata[i]);
+			g_ptr_array_foreach (ret_uids, (GFunc) g_free, NULL);
 			g_ptr_array_free (ret_uids, TRUE);
 		}
 	} else if (transferred_uids)
@@ -995,19 +969,15 @@ camel_exchange_folder_update_message_tag (CamelExchangeFolder *exch,
  * @camel_flags: the folder flags passed to camel_store_get_folder().
  * @folder_dir: local directory this folder can cache data into
  * @offline_state : offline status
- * @stub: the #CamelStub.
  * @ex: a #CamelException
  *
- * Constructs @folder by requesting the necessary data from the server
- * via @stub.
- *
  * Return value: success or failure.
  **/
 gboolean
 camel_exchange_folder_construct (CamelFolder *folder, CamelStore *parent,
 				 const gchar *name, guint32 camel_flags,
 				 const gchar *folder_dir, gint offline_state,
-				 CamelStub *stub, CamelException *ex)
+				 CamelException *ex)
 {
 	CamelExchangeFolder *exch = (CamelExchangeFolder *)folder;
 	const gchar *short_name;
@@ -1081,10 +1051,8 @@ camel_exchange_folder_construct (CamelFolder *folder, CamelStore *parent,
 		camel_message_info_free(info);
 	}
 
-	if (stub) {
-		gboolean ok, create = camel_flags & CAMEL_STORE_FOLDER_CREATE;
-
-		exch->stub = stub;
+	if (parent) {
+		gboolean ok, create = camel_flags & CAMEL_STORE_FOLDER_CREATE, readonly = FALSE;
 
 		summary = camel_folder_get_summary (folder);
 		uids = g_ptr_array_new ();
@@ -1106,17 +1074,9 @@ camel_exchange_folder_construct (CamelFolder *folder, CamelStore *parent,
 		}
 
 		camel_operation_start (NULL, _("Scanning for changed messages"));
-		ok = camel_stub_send (exch->stub, ex, CAMEL_STUB_CMD_GET_FOLDER,
-				      CAMEL_STUB_ARG_FOLDER, name,
-				      CAMEL_STUB_ARG_UINT32, create,
-				      CAMEL_STUB_ARG_STRINGARRAY, uids,
-				      CAMEL_STUB_ARG_BYTEARRAY, flags,
-				      CAMEL_STUB_ARG_STRINGARRAY, hrefs,
-				      CAMEL_STUB_ARG_UINT32, CAMEL_EXCHANGE_SUMMARY(folder->summary)->high_article_num,
-				      CAMEL_STUB_ARG_RETURN,
-				      CAMEL_STUB_ARG_UINT32, &folder_flags,
-				      CAMEL_STUB_ARG_STRING, &exch->source,
-				      CAMEL_STUB_ARG_END);
+		ok = camel_exchange_utils_get_folder (CAMEL_SERVICE (parent),
+				      name, create, uids, flags, hrefs, CAMEL_EXCHANGE_SUMMARY (folder->summary)->high_article_num,
+				      &folder_flags, &exch->source, &readonly, ex);
 		camel_operation_end (NULL);
 		g_ptr_array_free (uids, TRUE);
 		g_byte_array_free (flags, TRUE);
@@ -1125,25 +1085,23 @@ camel_exchange_folder_construct (CamelFolder *folder, CamelStore *parent,
 		if (!ok)
 			return FALSE;
 
-		if (folder_flags & CAMEL_STUB_FOLDER_FILTER)
+		if (folder_flags & CAMEL_FOLDER_FILTER_RECENT)
 			folder->folder_flags |= CAMEL_FOLDER_FILTER_RECENT;
-		if (folder_flags & CAMEL_STUB_FOLDER_FILTER_EXPUNGE)
+		if (folder_flags & CAMEL_FOLDER_FILTER_EXPUNGE)
 			folder->folder_flags |= CAMEL_FOLDER_FILTER_EXPUNGE;	
-		if (folder_flags & CAMEL_STUB_FOLDER_FILTER_JUNK)
+		if (folder_flags & CAMEL_FOLDER_FILTER_JUNK)
 			folder->folder_flags |= CAMEL_FOLDER_FILTER_JUNK;
 
-		camel_exchange_summary_set_readonly (folder->summary, folder_flags & CAMEL_STUB_FOLDER_READONLY);
+		camel_exchange_summary_set_readonly (folder->summary, readonly);
 
-		if (offline_state == CAMEL_OFFLINE_STORE_NETWORK_UNAVAIL )
+		if (offline_state == CAMEL_OFFLINE_STORE_NETWORK_UNAVAIL)
 			return TRUE;
 
 		if (len)
 			return TRUE;
 
 		camel_operation_start (NULL, _("Fetching summary information for new messages"));
-		ok = camel_stub_send (exch->stub, ex, CAMEL_STUB_CMD_REFRESH_FOLDER,
-				      CAMEL_STUB_ARG_FOLDER, folder->full_name,
-				      CAMEL_STUB_ARG_END);
+		ok = camel_exchange_utils_refresh_folder (CAMEL_SERVICE (parent), folder->full_name, ex);
 		camel_operation_end (NULL);
 		if (!ok)
 			return FALSE;
diff --git a/camel/camel-exchange-folder.h b/camel/camel-exchange-folder.h
index ed06d17..590355f 100644
--- a/camel/camel-exchange-folder.h
+++ b/camel/camel-exchange-folder.h
@@ -13,7 +13,6 @@ G_BEGIN_DECLS
 #include <camel/camel-data-cache.h>
 #include <camel/camel-offline-folder.h>
 #include <camel/camel-offline-journal.h>
-#include "camel-stub.h"
 
 #define CAMEL_EXCHANGE_FOLDER_TYPE     (camel_exchange_folder_get_type ())
 #define CAMEL_EXCHANGE_FOLDER(obj)     (CAMEL_CHECK_CAST((obj), CAMEL_EXCHANGE_FOLDER_TYPE, CamelExchangeFolder))
@@ -23,7 +22,6 @@ G_BEGIN_DECLS
 typedef struct {
 	CamelOfflineFolder parent_object;
 
-	CamelStub *stub;
 	CamelDataCache *cache;
 	CamelOfflineJournal *journal;
 	gchar *source;
@@ -45,7 +43,6 @@ gboolean camel_exchange_folder_construct            (CamelFolder *folder,
 						     guint32 camel_flags,
 						     const gchar *folder_dir,
 						     gint offline_state,
-						     CamelStub *stub,
 						     CamelException *ex);
 
 void     camel_exchange_folder_add_message          (CamelExchangeFolder *exch,
diff --git a/camel/camel-exchange-journal.c b/camel/camel-exchange-journal.c
index d8b2a9d..fe19e50 100644
--- a/camel/camel-exchange-journal.c
+++ b/camel/camel-exchange-journal.c
@@ -42,6 +42,7 @@
 #include "camel-exchange-journal.h"
 #include "camel-exchange-store.h"
 #include "camel-exchange-summary.h"
+#include "camel-exchange-utils.h"
 
 #define d(x)
 
@@ -231,20 +232,14 @@ exchange_message_info_dup_to (CamelMessageInfoBase *dest, CamelMessageInfoBase *
 static gint
 exchange_entry_play_delete (CamelOfflineJournal *journal, CamelExchangeJournalEntry *entry, CamelException *ex)
 {
-	CamelExchangeFolder *exchange_folder = (CamelExchangeFolder *) journal->folder;
-
-	camel_stub_send_oneway (exchange_folder->stub,
-				CAMEL_STUB_CMD_SET_MESSAGE_FLAGS,
-				CAMEL_STUB_ARG_FOLDER,
-				((CamelFolder *)exchange_folder)->full_name,
-				CAMEL_STUB_ARG_STRING,
-				entry->uid,
-				CAMEL_STUB_ARG_UINT32,
-				entry->set,
-				CAMEL_STUB_ARG_UINT32,
-				entry->flags,
-				CAMEL_STUB_ARG_END);
+	CamelFolder *folder = (CamelFolder *) journal->folder;
 
+	camel_exchange_utils_set_message_flags (CAMEL_SERVICE (folder->parent_store),
+					folder->full_name,
+					entry->uid,
+					entry->set,
+					entry->flags,
+					ex);
 	return 0;
 }
 
diff --git a/camel/camel-exchange-search.c b/camel/camel-exchange-search.c
index 2bdf1b9..a662cf7 100644
--- a/camel/camel-exchange-search.c
+++ b/camel/camel-exchange-search.c
@@ -30,6 +30,7 @@
 
 #include "camel-exchange-search.h"
 #include "camel-exchange-folder.h"
+#include "camel-exchange-utils.h"
 
 static ESExpResult *
 exchange_body_contains (struct _ESExp *f, gint argc, struct _ESExpResult **argv,
@@ -71,7 +72,6 @@ static ESExpResult *
 exchange_body_contains (struct _ESExp *f, gint argc, struct _ESExpResult **argv,
 			CamelFolderSearch *s)
 {
-	CamelExchangeFolder *folder = CAMEL_EXCHANGE_FOLDER (s->folder);
 	gchar *value = argv[0]->value.string, *real_uid;
 	const gchar *uid;
 	ESExpResult *r;
@@ -105,13 +105,7 @@ exchange_body_contains (struct _ESExp *f, gint argc, struct _ESExpResult **argv,
 	}
 
 	/* FIXME: what if we have multiple string args? */
-	if (!camel_stub_send (folder->stub, NULL,
-			      CAMEL_STUB_CMD_SEARCH_FOLDER,
-			      CAMEL_STUB_ARG_FOLDER, s->folder->full_name,
-			      CAMEL_STUB_ARG_STRING, value,
-			      CAMEL_STUB_ARG_RETURN,
-			      CAMEL_STUB_ARG_STRINGARRAY, &found_uids,
-			      CAMEL_STUB_ARG_END))
+	if (!camel_exchange_utils_search (CAMEL_SERVICE (s->folder->parent_store), s->folder->full_name, value, &found_uids, NULL))
 		return r;
 
 	if (!found_uids->len) {
